#ifndef __ARCHIVE_FORMAT__
#define __ARCHIVE_FORMAT__
#define CHUNK_ID_BAR (('B' << 24) | ('A' << 16) | ('R' << 8) | '0')
typedef struct {
} ChunkBar;
extern int CHUNK_DEFINITION_BAR[];
#define CHUNK_ID_KEY (('K' << 24) | ('E' << 16) | ('Y' << 8) | '0')
typedef struct {
} ChunkKey;
extern int CHUNK_DEFINITION_KEY[];
#define CHUNK_ID_FILE (('F' << 24) | ('I' << 16) | ('L' << 8) | '0')
typedef struct {
  uint16 compressAlgorithm;
  uint8 pad0[2];
  uint16 cryptAlgorithm;
  uint8 pad1[2];
} ChunkFile;
extern int CHUNK_DEFINITION_FILE[];
#define CHUNK_ID_FILE_ENTRY (('F' << 24) | ('E' << 16) | ('N' << 8) | 'T')
typedef struct {
  uint64 size;
  uint64 timeLastAccess;
  uint64 timeModified;
  uint64 timeLastChanged;
  uint32 userId;
  uint32 groupId;
  uint32 permission;
  String name;
} ChunkFileEntry;
extern int CHUNK_DEFINITION_FILE_ENTRY[];
#define CHUNK_ID_FILE_DATA (('F' << 24) | ('D' << 16) | ('A' << 8) | 'T')
typedef struct {
  uint64 fragmentOffset;
  uint64 fragmentSize;
} ChunkFileData;
extern int CHUNK_DEFINITION_FILE_DATA[];
#define CHUNK_ID_IMAGE (('I' << 24) | ('M' << 16) | ('G' << 8) | '0')
typedef struct {
  uint16 compressAlgorithm;
  uint8 pad0[2];
  uint16 cryptAlgorithm;
  uint8 pad1[2];
} ChunkImage;
extern int CHUNK_DEFINITION_IMAGE[];
#define CHUNK_ID_IMAGE_ENTRY (('I' << 24) | ('E' << 16) | ('N' << 8) | 'T')
typedef struct {
  uint16 fileSystemType;
  uint8 pad0[2];
  uint64 size;
  uint32 blockSize;
  String name;
} ChunkImageEntry;
extern int CHUNK_DEFINITION_IMAGE_ENTRY[];
#define CHUNK_ID_IMAGE_DATA (('I' << 24) | ('D' << 16) | ('A' << 8) | 'T')
typedef struct {
  uint64 blockOffset;
  uint64 blockCount;
} ChunkImageData;
extern int CHUNK_DEFINITION_IMAGE_DATA[];
#define CHUNK_ID_DIRECTORY (('D' << 24) | ('I' << 16) | ('R' << 8) | '0')
typedef struct {
  uint16 cryptAlgorithm;
  uint8 pad0[2];
} ChunkDirectory;
extern int CHUNK_DEFINITION_DIRECTORY[];
#define CHUNK_ID_DIRECTORY_ENTRY (('D' << 24) | ('E' << 16) | ('N' << 8) | 'T')
typedef struct {
  uint64 timeLastAccess;
  uint64 timeModified;
  uint64 timeLastChanged;
  uint32 userId;
  uint32 groupId;
  uint32 permission;
  String name;
} ChunkDirectoryEntry;
extern int CHUNK_DEFINITION_DIRECTORY_ENTRY[];
#define CHUNK_ID_LINK (('L' << 24) | ('N' << 16) | ('K' << 8) | '0')
typedef struct {
  uint16 cryptAlgorithm;
  uint8 pad0[2];
} ChunkLink;
extern int CHUNK_DEFINITION_LINK[];
#define CHUNK_ID_LINK_ENTRY (('L' << 24) | ('E' << 16) | ('N' << 8) | 'T')
typedef struct {
  uint64 timeLastAccess;
  uint64 timeModified;
  uint64 timeLastChanged;
  uint32 userId;
  uint32 groupId;
  uint32 permission;
  String name;
  String destinationName;
} ChunkLinkEntry;
extern int CHUNK_DEFINITION_LINK_ENTRY[];
#define CHUNK_ID_SPECIAL (('S' << 24) | ('P' << 16) | ('E' << 8) | '0')
typedef struct {
  uint16 cryptAlgorithm;
  uint8 pad0[2];
} ChunkSpecial;
extern int CHUNK_DEFINITION_SPECIAL[];
#define CHUNK_ID_SPECIAL_ENTRY (('S' << 24) | ('E' << 16) | ('N' << 8) | 'T')
typedef struct {
  uint16 specialType;
  uint8 pad0[2];
  uint64 timeLastAccess;
  uint64 timeModified;
  uint64 timeLastChanged;
  uint32 userId;
  uint32 groupId;
  uint32 permission;
  uint32 major;
  uint32 minor;
  String name;
} ChunkSpecialEntry;
extern int CHUNK_DEFINITION_SPECIAL_ENTRY[];
#endif /* __ARCHIVE_FORMAT__ */
