
#ifndef __ERRORS__
#define __ERRORS__

#define ERROR(code,errno)       ((((errno) << 16) & 0xFFFF0000) |                                                                                   (((ERROR_ ## code) << 0) & 0x000003FF))
#define ERRORX(code,errno,text) ((((errno) << 16) & 0xFFFF0000) | ((_Errors_textToIndex(text) << 10) & 0x0000FC00) | (((ERROR_ ## code) << 0) & 0x000003FF))


typedef enum
{
  ERROR_NONE = 0,
  ERROR_INSUFFICIENT_MEMORY = 1,
  ERROR_INIT = 2,
  ERROR_INVALID_ARGUMENT = 3,
  ERROR_CONFIG = 4,
  ERROR_ABORTED = 5,
  ERROR_FUNCTION_NOT_SUPPORTED = 6,
  ERROR_STILL_NOT_IMPLEMENTED = 7,
  ERROR_DAEMON_FAIL = 8,
  ERROR_INVALID_PATTERN = 9,
  ERROR_INIT_TLS = 10,
  ERROR_NO_TLS_CA = 11,
  ERROR_NO_TLS_CERTIFICATE = 12,
  ERROR_NO_TLS_KEY = 13,
  ERROR_INVALID_TLS_CA = 14,
  ERROR_INVALID_TLS_CERTIFICATE = 15,
  ERROR_TLS_CERTIFICATE_EXPIRED = 16,
  ERROR_TLS_CERTIFICATE_NOT_ACTIVE = 17,
  ERROR_TLS_HANDSHAKE = 18,
  ERROR_INVALID_SSH_SPECIFIER = 19,
  ERROR_NO_SSH_PASSWORD = 20,
  ERROR_INVALID_SSH_PASSWORD = 21,
  ERROR_SSH_SESSION_FAIL = 22,
  ERROR_SSH_AUTHENTIFICATION = 23,
  ERROR_SSH = 24,
  ERROR_INVALID_FTP_SPECIFIER = 25,
  ERROR_FTP_SESSION_FAIL = 26,
  ERROR_NO_FTP_PASSWORD = 27,
  ERROR_INVALID_FTP_PASSWORD = 28,
  ERROR_FTP_AUTHENTIFICATION = 29,
  ERROR_INIT_COMPRESS = 30,
  ERROR_COMPRESS_ERROR = 31,
  ERROR_DEFLATE_ERROR = 32,
  ERROR_INFLATE_ERROR = 33,
  ERROR_COMPRESS_EOF = 34,
  ERROR_UNSUPPORTED_BLOCK_SIZE = 35,
  ERROR_INIT_CRYPT = 36,
  ERROR_NO_CRYPT_PASSWORD = 37,
  ERROR_INVALID_PASSWORD = 38,
  ERROR_PASSWORDS_MISMATCH = 39,
  ERROR_INIT_CIPHER = 40,
  ERROR_ENCRYPT_FAIL = 41,
  ERROR_DECRYPT_FAIL = 42,
  ERROR_CREATE_KEY_FAIL = 43,
  ERROR_INVALID_KEY = 44,
  ERROR_INVALID_KEY_LENGTH = 45,
  ERROR_INVALID_BLOCK_LENGTH = 46,
  ERROR_NO_PUBLIC_KEY = 47,
  ERROR_NO_PRIVATE_KEY = 48,
  ERROR_NOT_A_PUBLIC_KEY = 49,
  ERROR_NOT_A_PRIVATE_KEY = 50,
  ERROR_KEY_ENCRYPT_FAIL = 51,
  ERROR_KEY_DECRYPT_FAIL = 52,
  ERROR_WRONG_PRIVATE_KEY = 53,
  ERROR_CREATE_FILE = 54,
  ERROR_OPEN_FILE = 55,
  ERROR_OPEN_DIRECTORY = 56,
  ERROR_IO_ERROR = 57,
  ERROR_READ_FILE = 58,
  ERROR_WRITE_FILE = 59,
  ERROR_DELETE_FILE = 60,
  ERROR_FILE_EXITS = 61,
  ERROR_FILE_NOT_FOUND = 62,
  ERROR_NOT_A_DIRECTORY = 63,
  ERROR_OPEN_DEVICE = 64,
  ERROR_INVALID_DEVICE_BLOCK_SIZE = 65,
  ERROR_READ_DEVICE = 66,
  ERROR_WRITE_DEVICE = 67,
  ERROR_PARSE_DEVICE_LIST = 68,
  ERROR_END_OF_ARCHIVE = 69,
  ERROR_NO_FILE_ENTRY = 70,
  ERROR_NO_FILE_DATA = 71,
  ERROR_NO_DIRECTORY_ENTRY = 72,
  ERROR_NO_LINK_ENTRY = 73,
  ERROR_NO_SPECIAL_ENTRY = 74,
  ERROR_NO_IMAGE_ENTRY = 75,
  ERROR_NO_IMAGE_DATA = 76,
  ERROR_END_OF_DATA = 77,
  ERROR_CRC_ERROR = 78,
  ERROR_FILE_INCOMPLETE = 79,
  ERROR_WRONG_FILE_TYPE = 80,
  ERROR_FILES_DIFFER = 81,
  ERROR_CORRUPT_DATA = 82,
  ERROR_NOT_AN_INCREMENTAL_FILE = 83,
  ERROR_WRONG_INCREMENTAL_FILE_VERSION = 84,
  ERROR_CORRUPT_INCREMENTAL_FILE = 85,
  ERROR_HOST_NOT_FOUND = 86,
  ERROR_CONNECT_FAIL = 87,
  ERROR_NO_LOGIN_NAME = 88,
  ERROR_NO_PASSWORD = 89,
  ERROR_NETWORK_SEND = 90,
  ERROR_NETWORK_RECEIVE = 91,
  ERROR_NETWORK_EXECUTE_FAIL = 92,
  ERROR_NO_RESPONSE = 93,
  ERROR_INVALID_RESPONSE = 94,
  ERROR_INVALID_DEVICE_SPECIFIER = 95,
  ERROR_LOAD_VOLUME_FAIL = 96,
  ERROR_FORK_FAIL = 97,
  ERROR_EXEC_FAIL = 98,
  ERROR_PARSING = 99,
  ERROR_EXPECTED_PARAMETER = 100,
  ERROR_UNKNOWN_VALUE = 101,
  ERROR_AUTHORIZATION = 102,
  ERROR_JOB_NOT_FOUND = 103,
  ERROR_JOB = 104,

  ERROR_UNKNOWN = 105
} Errors;

int _Errors_textToIndex(const char *text);
unsigned int Errors_getCode(Errors error);
const char *Errors_getText(Errors error);

#endif /* __ARCHIVE_FORMAT__ */
